#!/usr/bin/env python

from MoinMessage import Message
from email.mime.application import MIMEApplication
from email.mime.text import MIMEText
from os.path import split
import sys

def add_update(message, action, part):
    if action == "file":
        action = "store"
    part["Update-Action"] = action
    message.add_update(part)

def readfile(filename):
    f = open(filename, "rb")
    try:
        return MIMEApplication(f.read())
    finally:
        f.close()

if __name__ == "__main__":
    try:
        type = sys.argv[1]
        action = sys.argv[2]
        args = sys.argv[3:]
    except IndexError:
        args = None

    if not args:
        print >>sys.stderr, "Need an update type, update action and some updates as arguments to this program."
        sys.exit(1)

    message = Message()
    parts = []

    # Add each content fragment as either a separate update to a collection of
    # updates or as an alternative part to a single update.

    for arg in args:

        # Read files and assign filenames to them, or read argument strings, and
        # adopt them as parts.

        if action == "file":
            part = readfile(arg)
            part["Content-Disposition"] = split(arg)[-1]
        else:
            part = MIMEText(arg, "moin", sys.stdin.encoding)

        if type == "collection":
            add_update(message, action, part)
        else:
            parts.append(part)

    # Obtain the alternative representations as an update and add it to the
    # message.

    if type != "collection":
        multipart = message.get_update(parts)
        add_update(message, action, multipart)

    text = message.get_payload()
    print text

# vim: tabstop=4 expandtab shiftwidth=4
